/***********************************************
 *
 * OG Script Dumper v3.9 by learn_more
 * File: out\a198\script\cam_dump.as
 * Generated: 30-Apr-2013 21:21:41
 * Overgrowth.exe base: 0x1040000
 *
 ***********************************************/

#include "shared_dump.as"


/***********************************************
 * Files that can access these (and included) functions/objects/properties:
 */

	// cam.as


/***********************************************
 * Global Functions:
 */

vec3 __cdecl LineLineIntersect(vec3,vec3,vec3,vec3)			// 'Overgrowth.exe' + 0x2cd200 (0x130d200)


/***********************************************
 * Objects:
 */

class CollisionPoint
{		// size: 0x1c, flags:  asOBJ_VALUE asOBJ_POD asOBJ_APP_CLASS
	vec3 position;		// byteOffset: 0x0
	vec3 normal;		// byteOffset: 0xc
	int id;		// byteOffset: 0x18
};

class SphereCollision
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	float radius;		// byteOffset: 0x0
	vec3 position;		// byteOffset: 0x4
	vec3 adjusted_position;		// byteOffset: 0x10
//-----
	int NumContacts();		// 'Overgrowth.exe' + 0x2ce250 (0x130e250)
	CollisionPoint GetContact(int);		// 'Overgrowth.exe' + 0x2cd820 (0x130d820)
};

class ASCollisions
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	vec3 GetSlidingCapsuleCollision(vec3,vec3,float);		// 'Overgrowth.exe' + 0x2cda80 (0x130da80)
	void GetSlidingSphereCollision(vec3,float);		// 'Overgrowth.exe' + 0x2cd090 (0x130d090)
	void GetScaledSphereCollision(vec3,float,vec3);		// 'Overgrowth.exe' + 0x2cced0 (0x130ced0)
	void GetScaledSpherePlantCollision(vec3,float,vec3);		// 'Overgrowth.exe' + 0x2ccf20 (0x130cf20)
	void GetSlidingScaledSphereCollision(vec3,float,vec3);		// 'Overgrowth.exe' + 0x2cd040 (0x130d040)
	void GetCylinderCollision(vec3,float,float);		// 'Overgrowth.exe' + 0x2cce90 (0x130ce90)
	void GetSweptSphereCollision(vec3,vec3,float);		// 'Overgrowth.exe' + 0x2cd180 (0x130d180)
	void GetSweptSphereCollisionCharacters(vec3,vec3,float);		// 'Overgrowth.exe' + 0x2cd1d0 (0x130d1d0)
	void GetSweptCylinderCollision(vec3,vec3,float,float);		// 'Overgrowth.exe' + 0x2cd120 (0x130d120)
	void GetSweptBoxCollision(vec3,vec3,vec3);		// 'Overgrowth.exe' + 0x2cd0c0 (0x130d0c0)
	void CheckRayCollisionCharacters(vec3,vec3);		// 'Overgrowth.exe' + 0x2ccd90 (0x130cd90)
	vec3 GetRayCollision(vec3,vec3);		// 'Overgrowth.exe' + 0x2cd950 (0x130d950)
};

class GUI
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	uint32 AddGUI(string, string, int, int, uint8);		// 'Overgrowth.exe' + 0x2d8940 (0x1318940)
	void RemoveGUI(uint32);		// 'Overgrowth.exe' + 0x2de710 (0x131e710)
	void RemoveAll();		// 'Overgrowth.exe' + 0x2de6b0 (0x131e6b0)
	void Execute(uint32, string);		// 'Overgrowth.exe' + 0x2dd8b0 (0x131d8b0)
	void MoveTo(uint32, int, int);		// 'Overgrowth.exe' + 0x2de4c0 (0x131e4c0)
	string GetCallback(uint32);		// 'Overgrowth.exe' + 0x2dd9b0 (0x131d9b0)
	void Update();		// 'Overgrowth.exe' + 0x2de950 (0x131e950)
};

class CameraObject
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	vec3 position;		// byteOffset: 0x54
	bool controlled;		// byteOffset: 0x80
	bool frozen;		// byteOffset: 0xa4
	vec3 velocity;		// byteOffset: 0xa8
	bool ignore_mouse_input;		// byteOffset: 0xb8
//-----
	void LoadParallaxScene(string, string);		// 'Overgrowth.exe' + 0x235780 (0x1275780)
	void UnloadParallaxScene();		// 'Overgrowth.exe' + 0x235820 (0x1275820)
};

class CameraAnimationReader
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	void AttachTo(string);		// 'Overgrowth.exe' + 0xeabc0 (0x112abc0)
	vec3 GetPosition();		// 'Overgrowth.exe' + 0xeb490 (0x112b490)
	vec4 GetRotationVec4();		// 'Overgrowth.exe' + 0xeb9d0 (0x112b9d0)
	float GetLens();		// 'Overgrowth.exe' + 0xeb2c0 (0x112b2c0)
	void Update();		// 'Overgrowth.exe' + 0xec170 (0x112c170)
	bool valid();		// 'Overgrowth.exe' + 0xef030 (0x112f030)
};



/***********************************************
 * Global Properties:
 */

ASCollisions col;		// 0x2e35ea20
SphereCollision sphere_col;		// 0x2e35ea24
GUI gui;		// 0x28bf7110
uint8 _GG_IGNORES_MOUSE;		// 'Overgrowth.exe' + 0x5712c4 (0x15b12c4)
CameraObject co;		// 0x2936fe10
CameraAnimationReader camera_animation_reader;		// 0x2936fecc
